<?php
/*
Plugin Name: All in One Gallery
Plugin URI: http://sosobering.free.fr/art/?p=425
Description: Display and browse all the images on your wordpress website in one place using the new [ gallery ] shortcode. Thank to Karl Rixon ( http://www.karlrixon.co.uk/ ) for the php knowledge.
Version: 0.6.1
Author: Thomas Michalak aka TM
Author URI: http://sosobering.free.fr/art
*/

/*  Copyright 2008  Thomas Michalak  (email : http://sosobering.free.fr/art/?page_id=126 )

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*************************************************************/
/*   THE OPTION PANNEL THE OPTION PANNEL THE OPTION PANNEL   */
/*************************************************************/
add_option(select_page, '');
add_option(how_many_columms, '');
add_option(ecluded_cat, '');
add_option(welcome_message, 'All images that have been posted on '.get_bloginfo('name').' website are accessible here. Browse through the categories and view all images that are related to each category. Click on a thumbnail to see the full size. You can also read the related post by clicking on view this post');

add_action('admin_menu', 'all_in_one_gallery_menu');

function all_in_one_gallery_menu() {
        add_options_page('All in One Gallery Options', 'All in One Gallery', 8, __FILE__, 'all_in_one_gallery_options');
}

function all_in_one_gallery_options() {
        
	//A bit of style
	$websiteURL = get_bloginfo('url');
	echo'<link rel="stylesheet" type="text/css" href="'.$websiteURL.'/wp-content/plugins/all-in-one-gallery/option_css.css" />';
	
	
	//The form
	echo '<div class="wrap">';

        echo '<h2>All in one Gallery</h2>';
        echo '<h3>Display all you galleries in one place</h3>';
	
        echo '<form method="post" action="options.php">';
        wp_nonce_field('update-options');
        echo '<table class="form-table">';
        
	// 1st option
        echo '<tr valign="top">';
        echo '<th scope="row">Select in wich page you want to display the gallery</th>';
        echo '<td><select name="select_page">';
	$all_pages = get_posts('numberposts=-1&post_type=page&post_status= ');
	foreach($all_pages as $post){
		$aPost = get_post($post);
		if($aPost->post_title == get_option('select_page')){
		        $sel = 'selected = "selected"';	
		}else{
		        $sel = '';	
		}
		echo '<option value="'.$aPost->post_title.'"'.$sel.'>'.$aPost->post_title.' ('.$aPost->post_status.')</option>';
	}
	echo '</select></td>';
	//echo '<td><input type="text" name="select_page" value="'.get_option('select_page').'" /></td>';
        echo '</tr>';
        
	// 2nd Option
        echo '<tr valign="top">';
        echo '<th scope="row">exclude categories from showing</th>';
        echo '<td><ul id="exlu_cat_style">';
	$category = get_categories();
	foreach($category as $cat){
		$exlcu_cat = get_option('ecluded_cat');
		if($exlcu_cat[$cat->cat_name] == TRUE){
		        $sel = ' checked = true';
			$sel_style = ' class = selected';
		}else{
		        $sel = '';
			$sel_style = '';
		}
		echo '<li'.$sel_style.'><input type="checkbox"'.$sel.' name="'."ecluded_cat[{$cat->cat_name}]".'"/><label>'.$cat->cat_name.'</label></li>';
	}
	echo '</td></form></ul>';
	echo '</tr>';
	
	// 3rd Option
        echo '<tr valign="top">';
        echo '<th scope="row">Select how many columns in the gallery</th>';
        echo '<td><select name="how_many_columms">';
	for($i=2; $i<7; $i++){
		if($i == get_option('how_many_columms')){
		        $sel = 'selected = "selected"';	
		}else{
		        $sel = '';	
		}
		echo '<option value="'.$i.'"'.$sel.'>'.$i.'</option>';
	}
	echo '</select></td>';
	//echo '<td><input type="text" name="how_many_columms" value="'.get_option('how_many_columms').'" /></td>';
        echo '</tr>';
	
	// 4th Option
        echo '<tr valign="top">';
        echo '<th scope="row">Welcome Message</th>';
	$textarea_content = get_option('welcome_message');
        echo '<td><textarea class="textarea_style" name="welcome_message">';
	echo $textarea_content;
	echo '</textarea></td>';
        echo '</tr>';
	
        echo '</table>';

        echo '<input type="hidden" name="action" value="update" />';
        echo '<input type="hidden" name="page_options" value="select_page, how_many_columms, ecluded_cat, welcome_message" />';

        echo '<p class="submit">';
        echo '<input type="submit" name="Submit" value="Save Changes" />';
        echo '</p>';

        echo '</form>';

  
        echo '</div>';
}


/*************************************************************/
/*  THE PLUGIN THE PLUGIN THE PLUGIN THE PLUGIN THE PLUGIN   */
/*************************************************************/
function debug(){
	echo '<pre>';
	print_r($_GET);
	echo '</pre>';
}

/*check if the plugin should take effect*/
function takeEffect(){
        //Look at user's page choice
	$userPageChoice = get_option(select_page);
	//look at the current page name
	$my_page_name = get_the_title();
        //Check if it's a page and compare it with the user's page choice
	if (is_page() && $my_page_name === $userPageChoice){         
                $doIt = TRUE;
        }else{
                $doIt = FALSE;
        }
        return $doIt;
}

/*get users choice of category*/
function userChoice(){
	if(empty($_GET['catRequest'])){
		//Don't do anything
	}else{
		$cat_id = ($_GET['catRequest']);
	}
	
	return $cat_id;
}

/*Display the Categories*/
function myCategories($pageID, $user_cat_choice_id){
	$websiteURL = get_bloginfo('url');
	$category = get_categories();
        $exlcu_cat = get_option('ecluded_cat');
	echo '<div id="all_in_one">';
	echo '<div id="all_in_one_menu">';
	echo '<ul>';
	//All categories link
	//$my_Request = $websiteURL.'?page_id='.$pageID.'&catRequest=0';
	//echo '<a href="'.$my_Request.'">All</a> <strong>|</strong> ';
	//Each categories seperated
	foreach($category as $cat){
		$cat_name = $cat->cat_name;
		//Only display not-exlcuded categories
		if($exlcu_cat[$cat_name] == FALSE) {
	                $cat_id = $cat->cat_ID;
	                $my_Request = $websiteURL.'?page_id='.$pageID.'&catRequest='.$cat_id;
	                //highligh current category
		        if($cat_id === $user_cat_choice_id){
		                $sel = 'class="selected"';	
		        }
		        //Not selected
		        else{
		        	$sel = '';
		        }
		        echo '<li><a href="'.$my_Request.'" '.$sel.'>'.$cat_name.'</a></li>';
		}
	}
	echo '</ul>';
	echo '</div>';
}


/*Add the content*/
function addContent($content) {
        //debug();
	if (takeEffect() === TRUE){
		$my_page_ID = get_the_ID();
		$user_cat_choice_id = userChoice();
		//Display Categories menu
		$content .= myCategories($my_page_ID, $user_cat_choice_id);
		//Display Posts and Gallery for the selected category
		$content .= '<div id="all_in_one_gallery">';
	       //No choice means just arrived on the page
	        if(empty($user_cat_choice_id)){
			$content .= '<div id="all_in_one_welcome">';
			//$content .= '<h3> Welcome to <i>'.get_bloginfo('name').'</i> gallery</h3>';
			$content .= '<p>'.get_option('welcome_message').'</p>';
		        $content .= '</div>';
		}else{//Give what the user asked for
	                //get Posts
		        $myposts = get_posts('numberposts=-1&post_type=any&category='.$user_cat_choice_id);
	                foreach($myposts as $post){
	                        //Info about the post
			        $postID = $post->ID;
				$post_attachments = get_children('post_type=attachment&post_mime_type=image&post_parent='.$postID);
	                        if($post_attachments === FALSE){
			                $all_posts_attachements[] = FALSE;
			        }else{
			                $all_posts_attachements[] = TRUE;
			                //The post
			                //$content .= $postID.' ';
		                        $aPost = get_post($post);
		                        $content .= '<h3>'.$aPost->post_title.' <small>/ <a href="'.get_permalink($postID).'">view this post</a></small></h3>';
			                /*
			                //If you need to display infos about the attachements
			                foreach($attachments as $attach) {
		                        // Now the single attachment array or object is in $attach
			                $content .= $attach->post_type.':'.$attach->post_mime_type.'<br/>';
	                                }*/
			                //the Gallery
					$userColumnsChoice = get_option(how_many_columms);
			                $content .= '<div class="a_gallerie">';
					$content .= '[gallery id="'.$postID.'" columns="'.$userColumnsChoice.'"]';
	                                $content .= '</div>';
				}
	                }
	                //If there is no posts with attachements, say it
	                if(!in_array(TRUE, $all_posts_attachements)){
		                $content .= '<p>there is no images in this category</p>';
	                }else{
		                //don't say anything
	                }
	        }
		$content .= '</div>';
		$content .= '</div>';
        }

 return $content;

}

add_action('the_content', 'addContent');

/*****************************************************************************/
/*  CSS CSS CSS CSS CSS CSS CSS CSS CSS CSS CSS CSS CSS CSS CSS CSS CSS  CSS */
/*****************************************************************************/
function addCSS(){
        if(takeEffect() === true){
		$websiteURL = get_bloginfo('url');
	        echo '<link media="screen" type="text/css" href="'.$websiteURL.'/wp-content/plugins/all-in-one-gallery/all-in-one-gallery.css" rel="stylesheet"/>';
	}
}


add_action('wp_head', 'addCSS');


?>
